/**
 * Copyright (C) 2012 Matteo Tamigi
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, 
 * USA.
 */
 
#include "PDFSec.hpp"

//  Definizioni di tutte le funzioni pubbliche della classe PDFSec:
//  -Costruttori e distruttori
//  -Metodi SET e GET
//  -Metodi che permettono l'output (PrintInfos)
//  -Funzioni pubbliche che richiamano altre funzioni private (LoadPdfInfos)
 
PDFSec :: PDFSec () : 
        nomeFile(), is(),
        pswd(), userPswd() {    //Variabili relative al cracking
    infoPdf = NULL;
    clearPdfInfos ();
    //DEBUG INFOS
    verbose = false;
}

PDFSec :: ~PDFSec () {
    clearPdfInfos();
}


void PDFSec :: PrintInfos () {
    uint8_t ch;
    if ( infoPdf ) {
        cout << "File name: " << nomeFile << " dimension: " << dimFile << " byte" << endl;
        cout << "PDF version "<< infoPdf->version_major << "." << infoPdf->version_minor << endl;
        cout << "Security Handler: " << infoPdf->s_handler;
        cout << " version " << infoPdf->version << "." << infoPdf->revision << " length: " << infoPdf->length << endl;
        cout << "Permessi: " << infoPdf->permissions << endl;
        cout << "Encrypted Metadata: " << infoPdf->encryptMetaData << endl;
        cout << "FileID: ";
        for(unsigned i = 0; i < infoPdf->fileID.size(); i++) {
            ch = infoPdf->fileID[i];
            if(ch < 16)
                printf("0%x", ch);
            else
                printf("%x", ch);
        }
        cout << endl;
    }
    // Assume u_string and o_string is of length 32. Not safe, but the code
    //  as a whole needs a rewrite anyway
    if(ERRNOENCINFO != err ) {
        cout << "user_string: ";
        for(unsigned i = 0; i < infoPdf->u_string.size(); i++) {
            ch = infoPdf->u_string[i];
            if(ch < 16)
	            printf("0%x", ch);
            else
	            printf("%x", ch);
        }
        cout << endl;
    }
    if(ERRNOENCINFO != err ) {
        cout << "ownr_string: ";
        for(unsigned i = 0; i < infoPdf->o_string.size(); i++) {
            ch = infoPdf->o_string[i];
            if(ch < 16)
	           printf("0%x", ch);
            else
	           printf("%x", ch);
        }
        cout << endl;
    }
}

void PDFSec :: LoadPdfInfos ( ) {
    //Apro il file in modalit binaria
    is.open(nomeFile.c_str(),ifstream::binary);
    
    //Determino la dimensione totale del file
    is.seekg(0, ios::end);
    dimFile = is.tellg();
    is.clear();
    is.seekg(0, ios::beg);
    
    //Pulisco la memoria
    infoPdf = new EncData;
    //infoPdf->s_handler = new char[128];     //Per fastidi, genero qua la s_handler
    //infoPdf->fileID = NULL;
    //infoPdf->fileIDLen = 0;

    
    //Apro il file e verifico sia un pdf e recupero le info di cifratura
    err = readPdfFile();
    
    is.close();
}

EncData * PDFSec :: GetPdfInfos () {
    //Genero una nuova istanza di EncData e la passo per riferimento
    EncData * e = new EncData;
    *e = *infoPdf;
    /*e->s_handler = new char[128];
    e->o_string = new uint8_t[32];
    e->u_string = new uint8_t[32];
    e->fileID = new uint8_t[infoPdf->fileIDLen];
    //Copio i dati
    e = infoPdf;        //Copio tutti i dati non puntati
    //Copio tutti i dati puntati
    strcpy(e->s_handler,infoPdf->s_handler);
    for(unsigned i = 0; i < 32; i++) {
        e->o_string[i] = infoPdf->o_string[i];
        e->u_string[i] = infoPdf->u_string[i];
    }
    for(unsigned i = 0; i < infoPdf->fileIDLen; i++)
        e->fileID[i] = infoPdf->fileID[i];
    */
    return e;
}
