/**
 * Copyright (C) 2012 Matteo Tamigi
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, 
 * USA.
 */

#include "common.hpp"

#ifndef PASSWORDGENERATOR_HPP
#define PASSWORDGENERATOR_HPP

class PasswordGen {
    public:
        //Costruttori e distruttori
        //Per la prima versione faccio solo il bruteforcing senza dizionario
        //(a parer mio comunque mi sembra una cosa inutile!!!)
        PasswordGen ();
        PasswordGen ( const unsigned , const unsigned , const string );
        ~PasswordGen ();
        //Metodi SET e GET
        //void SetPswdMethod ( const PasswordMethod );
        void SetCharset ( const string );
        void SetState ( const unsigned , const unsigned , unsigned * );
        //Funzioni principali della classe
        void SetNextPswd ();
        char * GetPswd () { if(!EOS) {return pswd;} else {return NULL;} }
    private:
        //Variabili per l'impiego delle combinazioni di cifre
        uint8_t * charSet;  //Per l'ottimizzazione utilizzare una lista circolare
        unsigned lenSet;
        unsigned max_c , min_c;
        unsigned * state;       //Stato dell'avanzamento
        unsigned lenState;
        char * pswd;
        bool EOS;
};

#endif
