#ifndef RC4_H
#define RC4_H

#define SWAP( a , b ) { uint8_t tmp; tmp = a; a = b; b = tmp; }

vector<uint8_t> Rc4 ( vector<uint8_t> pszText, const vector<uint8_t> pszKey , unsigned len = 0 ) {
    register unsigned i = 0, j = 0, n = 0;
	register unsigned ilen = pszKey.size();
    uint8_t sbox[256];
    
	for (unsigned m = 0; m < 256; m++ )
		sbox[m] = m;
    
	for (unsigned m = 0; m < 256; m++ ) {
		n = (n + sbox[m] + pszKey[m % ilen]) & 0xff;
        SWAP(sbox[m],sbox[n]);
	}
    ilen = pszText.size();
    if( 0 == len || len > ilen )
	   len = ilen;
	for (unsigned m = 0; m < len; m++ ) {
		i = (i + 1) &0xff;
		j = (j + sbox[i]) &0xff;
		SWAP(sbox[i],sbox[j]);
    	pszText[m] ^=  sbox[(sbox[i] + sbox[j])&0xff];
    }
    return pszText;
}

#endif
